function digglerDoMenu(aEvent)
{
  var id = aEvent.target.getAttribute("id");
  if (id == "diggler-clear") {
    digglerClearLocation();
  }
  else {
    digglerSetUrl(aEvent);
  }
}

function digglerSetUrl(aEvent)
{
  var uriToLoad = aEvent.target.getAttribute("label");
  urlBar = document.getElementById("urlbar");
  urlBar.value = uriToLoad;
  loadURI(uriToLoad);
}

function digglerBuildMenu()
{
  urlBar = document.getElementById("urlbar");
  var url = urlBar.value;
  var siteUrl;

  urlMenu = document.getElementById("diggler-url-menu");

  // Build a list of items from the current url
  digglerClearTempMenuItems(urlMenu);
  if (url.length > 0) {
    var isFirstTempItem = true;

    // Regexp to find the last slash delimited chunk of the url
    siteUrl = url;
    var tmpUrl = url;
    var reChunk = /[^\/]\/[^\/]+\/*$/; 
    while (1)
    {
      if (isFirstTempItem) {
        digglerCreateTempMenuSeparator(urlMenu);
        isFirstTempItem = false;
      }
      dump("Adding menu item for URL part = " + url + "\n");
      digglerCreateTempMenuItem(urlMenu, tmpUrl);

      var lastChunk = tmpUrl.search(reChunk);
      if (lastChunk == -1) {
        break;
      }
      // The + 2 bit is here because we want to slice 2 chars into the regexp
      tmpUrl = tmpUrl.slice(0, lastChunk + 2); 
      siteUrl = tmpUrl;
    }
  }

  // If the url starts with http:// then offer ftp:// as an alternative
  var urlAsFtp = siteUrl.replace(/^http:\/\/www/i, "ftp://ftp");
  if (urlAsFtp == siteUrl) {
    urlAsFtp = siteUrl.replace(/^http:\/\//i, "ftp://");
  }
  if (urlAsFtp != siteUrl) {
    digglerCreateTempMenuSeparator(urlMenu);
    digglerCreateTempMenuItem(urlMenu, urlAsFtp);
  }
  else {
    // If the url starts with ftp:// then offer http:// as an alternative
    var urlAsHttp = siteUrl.replace(/^ftp:\/\/ftp/i, "http://www");
    if (urlAsHttp == siteUrl) {
      urlAsHttp = siteUrl.replace(/^ftp:\/\//i, "http://");
    }
    if (urlAsHttp != siteUrl) {
      digglerCreateTempMenuSeparator(urlMenu);
      digglerCreateTempMenuItem(urlMenu, urlAsHttp);
    }
  }
}

function digglerClearTempMenuItems(aParent)
{
  var children = aParent.childNodes;
  for (var i = 0; i < children.length; i++)
  {
    var index = children[i].getAttribute("tmp");
    if (index)
      aParent.removeChild(children[i]);
  }
}

function digglerCreateTempMenuSeparator(aParent)
{
  var menuitem = document.createElement("menuseparator");
  menuitem.setAttribute("tmp", "separator");
  aParent.appendChild(menuitem);
}

function digglerCreateTempMenuItem(aParent, aLabel)
{
  var menuitem = document.createElement("menuitem");
  menuitem.setAttribute("label", aLabel);
  menuitem.setAttribute("tmp", "item");
  aParent.appendChild(menuitem);
}

function digglerClearLocation()
{
  urlBar = document.getElementById("urlbar");
  urlBar.value = "";
  urlBar.focus();
}

function digglerAbout()
{
}